/**
* Copyright (C) 2014 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.cdm.api.application;

import javax.sql.DataSource;

import org.hibernate.SessionFactory;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.transaction.PlatformTransactionManager;
import org.springframework.transaction.TransactionStatus;

import eu.etaxonomy.cdm.api.conversation.ConversationHolder;
import eu.etaxonomy.cdm.api.conversation.ConversationHolderMock;
import eu.etaxonomy.cdm.api.service.IDatabaseService;
import eu.etaxonomy.cdm.ext.geo.IEditGeoService;


/**
 * CDM Application Configuration class which manages the configuration for remoting
 * clients
 *
 */
@Component
public class CdmApplicationRemoteConfiguration extends CdmApplicationDefaultConfiguration {
	
	@SuppressWarnings("unused")
	private static final Logger logger = Logger.getLogger(CdmApplicationRemoteConfiguration.class);

	@Autowired
	IEditGeoService editGeoService;
	
	public CdmApplicationRemoteConfiguration() {
	}
	
    /* (non-Javadoc)
     * @see eu.etaxonomy.cdm.api.application.CdmApplicationDefaultConfiguration#getTransactionManager()
     */
    @Override
    public PlatformTransactionManager getTransactionManager() throws UnsupportedOperationException {
		throw new UnsupportedOperationException("getTransactionManager is not implemented for CdmApplicationRemoteConfiguration");
	}


    /* (non-Javadoc)
     * @see eu.etaxonomy.cdm.api.application.ICdmApplicationConfiguration#startTransaction()
     */
    @Override
    public TransactionStatus startTransaction() throws UnsupportedOperationException {
		throw new UnsupportedOperationException("startTransaction is not implemented for CdmApplicationRemoteConfiguration");
	}


    /* (non-Javadoc)
     * @see eu.etaxonomy.cdm.api.application.ICdmApplicationConfiguration#startTransaction()
     */
    @Override
    public TransactionStatus startTransaction(Boolean readOnly) throws UnsupportedOperationException {
		throw new UnsupportedOperationException("startTransaction is not implemented for CdmApplicationRemoteConfiguration");
	}


    /* (non-Javadoc)
     * @see eu.etaxonomy.cdm.api.application.CdmApplicationDefaultConfiguration#commitTransaction(org.springframework.transaction.TransactionStatus)
     */
    @Override
    public void commitTransaction(TransactionStatus txStatus) throws UnsupportedOperationException {
		throw new UnsupportedOperationException("commitTransaction is not implemented for CdmApplicationRemoteConfiguration");
	}
			
	/* (non-Javadoc)
	 * @see eu.etaxonomy.cdm.api.application.CdmApplicationDefaultConfiguration#NewConversation()
	 */
	@Override
	public ConversationHolder NewConversation() {		
		return new ConversationHolderMock();
	}
	
	/**
	 * @return
	 */
	public IEditGeoService getEditGeoService() {
		return this.editGeoService;
	}
	
	/* (non-Javadoc)
	 * @see eu.etaxonomy.cdm.api.application.CdmApplicationDefaultConfiguration#setDataSource(javax.sql.DataSource)
	 */
	@Override
	public void setDataSource(DataSource dataSource) {        		
    }
	
	/* (non-Javadoc)
	 * @see eu.etaxonomy.cdm.api.application.CdmApplicationDefaultConfiguration#setTransactionManager(org.springframework.transaction.PlatformTransactionManager)
	 */
	@Override
	public void setTransactionManager(PlatformTransactionManager transactionManager) {        
    }
	
	/* (non-Javadoc)
	 * @see eu.etaxonomy.cdm.api.application.CdmApplicationDefaultConfiguration#setSessionFactory(org.hibernate.SessionFactory)
	 */
	@Override
    public void setSessionFactory(SessionFactory sessionFactory) {    	
    }
}
