package eu.etaxonomy.cdm.api.cache;

import java.util.UUID;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import eu.etaxonomy.cdm.api.service.ITermService;
import eu.etaxonomy.cdm.model.common.CdmBase;

/**
 * Class which uses CDM services to cache cdm entities
 * 
 * FIXME: Currently only handles terms entities. It would be 
 *        interesting to have a generic method which finds the
 *        correct service to load / cache the entity.
 * 
 * @author cmathew
 *
 * @param <T>
 */
@Component
public class CdmServiceCacher<T extends CdmBase> extends CdmCacher<T> {

	@Autowired
	ITermService termService;
	
	@Override
	protected T findByUuid(UUID uuid) {
		return (T)termService.findWithoutFlush(uuid);
	}

}
