/**
* Copyright (C) 2014 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.httpinvoker;

import org.apache.log4j.Logger;
import org.junit.Assert;
import org.junit.Test;

import eu.etaxonomy.cdm.config.CdmSourceException;

/**
 * Class to test the HttpInvoker services exposed by the CDM Sever
 *
 */
public class HttpInvokerServicesTest extends BaseRemotingTest {
	private static final Logger logger = Logger.getLogger(HttpInvokerServicesTest.class);

	@Test
	public void whenCallingMethodsOnRemoteServicesThenSuceed() {
		try {
			String dbSchemaVersion = getRemoteApplicationController().getDatabaseService().getDbSchemaVersion();
			logger.info("dbSchemaVersion is " + dbSchemaVersion);
		} catch (CdmSourceException e) {
			Assert.fail("pinging database service on active cdm server should not have thrown CdmSourceException");
		}
	}

}
