package eu.etaxonomy.taxeditor.lazyloading;

import org.apache.log4j.Level;
import org.apache.log4j.Logger;
import org.junit.Assert;
import org.junit.BeforeClass;
import org.junit.Test;

import eu.etaxonomy.cdm.api.cache.CdmServiceCacher;
import eu.etaxonomy.cdm.model.common.Language;
import eu.etaxonomy.taxeditor.httpinvoker.BaseRemotingTest;

public class CdmServiceCacherTest extends BaseRemotingTest {
	private static final Logger logger = Logger.getLogger(CdmServiceCacherTest.class);


	private static CdmServiceCacher cdmServiceCacher;

	@BeforeClass
	public static void initialize() {
		Logger.getRootLogger().setLevel(Level.INFO);
		cdmServiceCacher = (CdmServiceCacher)getRemoteApplicationController().getBean("cdmServiceCacher");
	}

	@Test
	public void testLanguageCache() {
		Language defaultLanguage = Language.getDefaultLanguage();

		Language defaultLanguageInCache = (Language)cdmServiceCacher.getFromCache(defaultLanguage.getUuid());
		Assert.assertEquals("Loaded Language Term should match Language Term in Cache",defaultLanguage,defaultLanguageInCache);

		Language language = Language.getLanguageFromUuid(Language.uuidFrench);
		Language languageInCache = (Language)cdmServiceCacher.getFromCache(language.getUuid());
		Assert.assertEquals("Loaded Language Term should match Language Term in Cache",language,languageInCache);

	}

}
